poj 3126 Prime Path

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 17252 Accepted: 9710

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

提示

题意:

给你两个素数(四位),第一个素数每次可以改变某位上的数字,需要最少改变几次才能和第二个相同,并且改变的过程中得到的数也必须是素数才行。

思路:

我的做法是1000-9999先打表,用四维数组存,每一位做数组下标。第一个素数进行BFS每一位,要注意的是要记录上次改变的是哪一位,以防步骤重复。

示例程序

Source Code

Problem: 3126		Code Length: 3156B
Memory: 452K		Time: 0MS
Language: GCC		Result: Accepted
#include <stdio.h>
#include <string.h>
#include <math.h>
struct
{
    int a,b,c,d,step,w;			//a是千位,b是百位,c是十位,d是个位,step是步数,w是上一次改变的位数
}q[80000];
int num[10][10][10][10];
int bfs(int n,int m)
{
    int v[10][10][10][10],f=0,top=0,a1,b1,c1,d1,w1,i;			//这里a1,b1,c1,d1,w1和上面一样
    memset(v,0,sizeof(v));
    q[top].a=n/1000;
    q[top].b=n/100%10;
    q[top].c=n%100/10;
    q[top].d=n%10;
    q[top].w=0;					//一开始一位都没变那么每一位都要去搜一下
    q[top].step=0;
    v[q[top].a][q[top].b][q[top].c][q[top].d]=1;
    top++;
    while(f<top)
    {
        a1=q[f].a;
        b1=q[f].b;
        c1=q[f].c;
        d1=q[f].d;
        w1=q[f].w;
        if(a1==m/1000&&b1==m/100%10&&c1==m%100/10&&d1==m%10)
        {
            return q[f].step;
        }
        if(w1!=1)				//上一次改变的是第一位(千位),再改变就重复了,下面的也一样
        {
            for(i=1;10>i;i++)				//因为是四位数,i直接从1开始,但下面就是从0开始
            {
                if(v[i][b1][c1][d1]==0&&num[i][b1][c1][d1]==1)
                {
                    q[top].a=i;
                    q[top].b=b1;
                    q[top].c=c1;
                    q[top].d=d1;
                    q[top].w=1;
                    q[top].step=q[f].step+1;
                    v[q[top].a][q[top].b][q[top].c][q[top].d]=1;
                    top++;
                }
            }
        }
        if(w1!=2)
        {
            for(i=0;10>i;i++)
            {
                if(v[a1][i][c1][d1]==0&&num[a1][i][c1][d1]==1)
                {
                    q[top].a=a1;
                    q[top].b=i;
                    q[top].c=c1;
                    q[top].d=d1;
                    q[top].w=2;
                    q[top].step=q[f].step+1;
                    v[q[top].a][q[top].b][q[top].c][q[top].d]=1;
                    top++;
                }
            }
        }
        if(w1!=3)
        {
            for(i=0;10>i;i++)
            {
                if(v[a1][b1][i][d1]==0&&num[a1][b1][i][d1]==1)
                {
                    q[top].a=a1;
                    q[top].b=b1;
                    q[top].c=i;
                    q[top].d=d1;
                    q[top].w=3;
                    q[top].step=q[f].step+1;
                    v[q[top].a][q[top].b][q[top].c][q[top].d]=1;
                    top++;
                }
            }
        }
        if(w1!=4)
        {
            for(i=0;10>i;i++)
            {
                if(v[a1][b1][c1][i]==0&&num[a1][b1][c1][i]==1)
                {
                    q[top].a=a1;
                    q[top].b=b1;
                    q[top].c=c1;
                    q[top].d=i;
                    q[top].w=4;
                    q[top].step=q[f].step+1;
                    v[q[top].a][q[top].b][q[top].c][q[top].d]=1;
                    top++;
                }
            }
        }
        f++;
    }
}
int main()
{
    int t,n,m,i,i1;
    memset(num,0,sizeof(num));
    for(i=1000;9999>=i;i++)				//打表
    {
        for(i1=2;sqrt(i)>=i1;i1++)
        {
            if(i%i1==0)
            {
                break;
            }
        }
        if(sqrt(i)<i1)
        {
            num[i/1000][i/100%10][i%100/10][i%10]=1;
        }
    }
    scanf("%d",&t);
    for(i=1;t>=i;i++)
    {
        scanf("%d %d",&n,&m);
        printf("%d\n",bfs(n,m));
    }
    return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值